import json
import os

from data_generate.split_generator import SplitGenerator

if __name__ == "__main__":
    # load config file
    config_name = 'ptl_bomla_lam1.json'
    jsonfile = open(os.path.join('./config/la_seqdataset', config_name))
    config = json.loads(jsonfile.read())

    split_dir = os.path.join(os.path.join(config['data_dir'], config['split_folder']), 'cifar_fs')
    dest_dir = os.path.join(config['data_dir'], 'cifar_fs')

    # or use bertinetto's split
    os.makedirs(split_dir)

    metatrain = [os.path.join(os.path.join(config['data_dir'], 'cifar100'), line.rstrip('\n'))
                 for line in open('../data/cifar100_split/train.txt', 'r')]
    metaval = [os.path.join(os.path.join(config['data_dir'], 'cifar100'), line.rstrip('\n'))
               for line in open('../data/cifar100_split/val.txt', 'r')]
    metatest = [os.path.join(os.path.join(config['data_dir'], 'cifar100'), line.rstrip('\n'))
                for line in open('../data/cifar100_split/test.txt', 'r')]

    import numpy as np
    np.save(os.path.join(split_dir, 'metatrain.npy'), metatrain)
    np.save(os.path.join(split_dir, 'metaval.npy'), metaval)
    np.save(os.path.join(split_dir, 'metatest.npy'), metatest)
