import os
import json
from data_generate.split_generator import SplitGenerator


if __name__ == "__main__":
    # load config file
    config_name = 'omni_bomla_lam1.json'
    jsonfile = open(os.path.join('./config/la_seqtask', config_name))
    config = json.loads(jsonfile.read())

    split_dir = os.path.join(os.path.join(config['data_dir'], config['split_folder']), 'omniglot_seqtask')
    dest_dir = os.path.join(config['data_dir'], 'omniglot_seqtask')

    split_omniglot = SplitGenerator(
        data_dir=os.path.join(config['data_dir'], 'omniglot_raw'), dest_dir=dest_dir, split_dir=split_dir,
        back_eval_raw=True, supercls_raw=True, supercls_split=config['supercls']
    )
    split_omniglot.split_train_val_test(nclass_train=35, nclass_val=7, save_split_npy=False, csv_save_form=None)
    split_omniglot.generate_foldersplit(save_split_npy=True)
